#define led1 LATC0_bit
//  #define led2 LATC1_bit
#define led3 LATB7_bit

#define led4 LATB6_bit

#define Enco_A RB0_bit
#define Enco_B RB1_bit

char cuenta=0;
char dato_recibido;
char trama_rx[50];       // Vector

char contador_trama=0;
char flag_rx=0;

// LCD module connections
sbit LCD_RS at RB2_bit;
sbit LCD_EN at RA4_bit;
sbit LCD_D4 at RA0_bit;
sbit LCD_D5 at RA1_bit;
sbit LCD_D6 at RA2_bit;
sbit LCD_D7 at RA3_bit;

sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISA4_bit;
sbit LCD_D4_Direction at TRISA0_bit;
sbit LCD_D5_Direction at TRISA1_bit;
sbit LCD_D6_Direction at TRISA2_bit;
sbit LCD_D7_Direction at TRISA3_bit;
// End LCD module connections

signed int volum=0;
char tex[50];

  void procesa_rx()
  {
    if(strstr(trama_rx,"led1="))
    {
      if (strstr(trama_rx,"on"))led4=1;
       else led4=0;
    
    
    }
  
  
  
  
  }


  void interrupcion() iv 0x0008 ics ICS_AUTO

 {
    if (RCIF_bit==1)
    {
       dato_recibido=UART1_Read();
      // TXREG=dato_recibido;
    
       trama_rx[contador_trama]= dato_recibido;
       contador_trama++;
           
           if (contador_trama>50)contador_trama=0;
           
           // validar una trama correcta
           
           if (dato_recibido=='*')
           {
              flag_rx=1;
              RCIE_bit=0;    // DESHABILITAMOS INTERRUPCION SERIAL
           
           
           
           }
    
    
     RCIF_bit=0;
    }
    
    
    if (TMR1IF_bit==1) 
    {

            TMR1H=60;
            TMR1L=175;
            
            cuenta++;
            if (cuenta>=10)
            {

                led3=!led3;
                cuenta=0;
                
            }

    

    
      TMR1IF_bit=0;
    }



  if (INT0IF_bit==1)
  {
    if (Enco_A == Enco_B) volum++;
     else volum--;

       if (volum >= 255) volum = 255;                            //  Limite superior del encoder
       if (volum <= 0) volum = 0;                                 //  Limite inferior del encoder
  
       INTEDG0_bit=!INTEDG0_bit;                     // Instruccion para pasar de 1x a 2x en el encoder
  
     
     
     INT0IF_bit=0;                                  // Limpiamos la bandera de la interrupcion 0 al final

    }


       if (INT1IF_bit==1)
       {
          if  (Enco_A == Enco_B) volum--;
             else volum++;
       
              if (volum >= 255) volum = 255;                      //  Limite superior del encoder
              if (volum <= 0) volum = 0;                             //  Limite inferior del encoder

             INTEDG1_bit=!INTEDG1_bit;               // Instruccion para pasar de 1x a 2x en el encoder
       
       
       
       
       
        INT1IF_bit=0;                                 // Limpiamos la bandera de la interrupcion 1 al final
       }


}


void main() 
{
   ADCON1=0b1111;
     TRISC2_bit=0;
     PWM1_Init(250);
     PWM1_Set_Duty(0);
     PWM1_Start();
     
          Lcd_Init();
     
         Lcd_Cmd(_LCD_CLEAR);                   // Clear display
       Lcd_Cmd(_LCD_CURSOR_OFF);               // Cursor off
        Lcd_Out(1,1, "VELOCIDAD=");                 // Write text in first row

   
   TRISC0_bit=0;
   TRISC1_bit=0;
   TRISB0_bit=1;                               // Pin RB0 del microcontrolador asociado a la interrupcion 0
   TRISB1_bit=1;                               // Pin RB1 del microcontrolador asociado a la interrupcion 1
   TRISB7_bit=0;
     TRISB6_bit=0;
     
     
    UART1_Init(9600);                           // Inicia comunicacion serial a 9600 Baudios
    UART1_Write_Text("HOLA\r\n");
   
   TRISC6_bit=0;                             // Salida del TX microcontrolador
   TRISC7_bit=1;                             // Entrada del RX microcontrolador
   

   
   // Configuracion de la interrupcion INT0IF
   
   INTCON=0b01000000;             // Autoriza los mandos medios
       INT0IF_bit=0;
   
        INT0IE_bit=1;

      INTEDG0_bit=1;            // Interrupcion por flanco de subida


      // Configuracion de la interrupcion INT1IF

          INT1IF_bit=0;
          INT1IE_bit=1;
          INTEDG1_bit=1;          // Interrupcion por flanco de subida
            
           
           // configuramos interrupcion del timer 1
          
            T1CON=0;
            // CONFIGURACION PARA 200 ms
            
            TMR1H=60;
            TMR1L=175;
            
            // CONFIGURACION DEL PREESCALADOR
            
            T1CKPS1_bit=1;
            T1CKPS0_bit=0;
            
            TMR1IF_bit=0;        // LIMPIAR BANDERA
            TMR1IE_bit=1;        // HABILITAR BANDERA
            
            TMR1ON_bit=1;           // PRENDE EL TIMER 1
            
            
            // configuracion de interrupcion serial
            
            RCIF_bit=0;
            RCIE_bit=1;
            
            
            
            
            
            
            GIE_bit=1;                // Autoriza o habilita todas las interrupciones


       
       while(1)
       {
          led1=!led1;

       
          sprintf(tex,"%d\r\n\r\n",(signed int)volum*100/255);
            UART1_Write_Text(tex);
            
            Lcd_Out(2,10, tex);
            PWM1_Set_Duty(volum);
       
            Delay_ms(200);
            
            if (flag_rx==1)
            {
                procesa_rx();
            
            
            
            
              flag_rx=0;
              
              contador_trama=0;
              RCIF_bit=0;
              
              RCIE_bit=1;
            }
            
       
       }    // Final llave while (1)
   
   






}    // Final llave void main